Package: LBI
Version: 0.2.5
Title: Likelihood Based Inference
Description: Maximum likelihood estimation and likelihood ratio test are essential for modern statistics. This package supports in calculating likelihood based inference.
             Reference: Pawitan Y. (2001, ISBN:0-19-850765-8).
Depends: R (>= 3.0.0)
Authors@R: person(given="Kyun-Seop", family="Bae", role=c("aut", "cre", "cph"), email="k@acr.kr")
Author: Kyun-Seop Bae [aut, cre, cph]
Maintainer: Kyun-Seop Bae <k@acr.kr>
Copyright: 2023-, Kyun-Seop Bae
License: GPL-3
Repository: CRAN
URL: https://cran.r-project.org/package=LBI
NeedsCompilation: no
Date/Publication: 2026-06-10 22:20:02 UTC
Packaged: 2026-06-10 22:06:49 UTC; Kyun-SeopBae
Built: R 4.6.0; ; 2026-06-11 01:51:25 UTC; unix

LIvtest = function(s1, n1, s2, n2, k, conf.level=0.95)
{
  n1v1 = (n1 - 1)*s1^2 ; v1 = n1v1/n1
  n2v2 = (n2 - 1)*s2^2 ; v2 = n2v2/n2
  R0 = v1/v2
  n = n1 + n2
  maxLL = -(n1*(log(2*pi*v1) + 1) + n2*(log(2*pi*v2) + 1))/2 

  if (!missing(k)) {
    logk = log(k)
    conf.level = pf((n - 1)*(k^(2/n) - 1), 1, n - 1)
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 2.4)/(n - 2.4)) # empirical for two parameters
    logk = min(logk, log(2/(1 - conf.level)))
  }

  Obj = function(r) {
    mLL = function(v2t) (n1*log(2*pi*r*v2t) + n1v1/(r*v2t) + n2*log(2*pi*v2t) + n2v2/v2t)/2
    v2t = nlminb(v2, mLL, lower=1e-8, upper=1e6*v2)
    return(maxLL + v2t$objective - logk)
  }

  options(warn=-1)
  LL = uniroot(Obj, c(0, R0))$root
  UL = uniroot(Obj, c(R0, 1e9))$root
  options(warn=0)

  Res = c(group1=v1, group2=v2, PE=R0, LL=LL, UL=UL)
  Res = rbind(Res, sqrt(Res))
  rownames(Res) = c("var", "sd")
  attr(Res, "logk") = logk
  attr(Res, "maxLL") = maxLL
  attr(Res, "conf.level") = conf.level
  return(Res)
}

LInorm = function(x, k, conf.level=0.95, PLOT="", LOCATE=FALSE, Resol=201)
{
  x = x[!is.na(x)]
  n0 = length(x)
  if (!is.numeric(x) | sum(is.infinite(x) > 0) | sum(is.nan(x)) > 0 | n0 < 3 | length(unique(x)) == 1) stop("Check the input!")
  sxx = sum(x^2) ; sx = sum(x)
  m0 = sx/n0
  n0v0 = sxx - sx^2/n0
  v0 = n0v0/n0
  s0 = sqrt(v0)
  maxLL = -n0*(log(2*pi*v0) + 1)/2

  if (!missing(k)) {
    logk = log(k)
  } else {
    logk = n0/2*log(1 + 1*qf(conf.level, 1, n0 - 1.2)/(n0 - 1.2)) # 1.2 is empirical
    logk = min(logk, log(2/(1 - conf.level)))
  }

  O1 = function(th) maxLL + (n0*log(2*pi*v0) + (sxx - 2*th*sx + n0*th^2)/v0)/2 - logk
  O2 = function(th) maxLL + (n0*log(2*pi*th) + n0v0/th)/2 - logk

  options(warn=-1)  
  meanLL = uniroot(O1, c(m0 - 10*s0, m0))$root
  meanUL = uniroot(O1, c(m0, m0 + 10*s0))$root
  varLL = uniroot(O2, c(1e-8, v0))$root
  varUL = uniroot(O2, c(v0, 1e6*v0))$root
  options(warn=0)

  sdLL = sqrt(varLL)
  sdUL = sqrt(varUL)
  Res = cbind(PE = c(m0, s0, v0), LL=c(meanLL, sdLL, varLL), UL=c(meanUL, sdUL, varUL))
  rownames(Res) = c("mean", "sd", "var")
  attr(Res, "n") = n0
  attr(Res, "k") = exp(logk)
  attr(Res, "log(k)") = logk
  attr(Res, "maxLogLik") = maxLL

  if (toupper(trimws(PLOT)) %in% c("1D", "PROFILE")) {
    x1 = seq(m0 - 2*(m0 - meanLL), m0 + 2*(meanUL - m0), length.out=Resol)
    y1 = rep(NA, Resol)
    for (i in 1:Resol) y1[i] = sum(dnorm(x, mean=x1[i], sd=s0, log=TRUE))

    x2 = seq(max(1e-4, s0 - 2*(s0 - sdLL)), max(0, s0 + 2*(sdUL - s0)), length.out=Resol)
    y2 = rep(NA, Resol)
    for (i in 1:Resol) y2[i] = sum(dnorm(x, mean=m0, sd=x2[i], log=TRUE))

    oPar = par(mfrow=c(2, 2))

    plot(x1, y1, type="l", xlab="Mean", ylab="log Likelihood", ylim=c(maxLL - 3*logk, maxLL))
    abline(h=maxLL - logk, col="red")

    plot(x2, y2, type="l", xlab="Standard Deviation", ylab="log Likelihood", ylim=c(maxLL - 3*logk, maxLL))
    abline(h=maxLL - logk, col="red")

    plot(x1, exp(y1), type="l", xlab="Mean", ylab="Likelihood")
    abline(h=exp(maxLL - logk), col="red")

    plot(x2, exp(y2), type="l", xlab="Standard Deviation", ylab="Likelihood")
    abline(h=exp(maxLL - logk), col="red")

    par(oPar)
  } else if (toupper(trimws(PLOT)) %in% c("2D", "CONTOUR")) {
    Xs = seq(m0 - 2*(m0 - meanLL), m0 + 2*(meanUL - m0), length.out=Resol)
    Ys = seq(max(1e-4, s0 - 2*(s0 - sdLL)), s0 + 2*(sdUL - s0), length.out=Resol)
    mLik = matrix(NA, nrow=Resol, ncol=Resol)
    for (i in 1:Resol) for (j in 1:Resol) mLik[i, j] = sum(dnorm(x, mean=Xs[i], sd=Ys[j], log=TRUE))
    mLik[mLik < maxLL - 3*logk] = maxLL - 3*logk
    contour(Xs, Ys, mLik, xlab="Mean", ylab="Standard Deviation")
    contour(Xs, Ys, mLik, nlevels=1, levels=maxLL - logk, col="red", add=TRUE)
    abline(h=s0, v=m0, lty=3)
    points(m0, s0, pch="+", col="red")

    if (LOCATE) {
      print(Res)
      options(locatorBell = FALSE) # locator bell is annoying
      while (TRUE) {
        ans = locator(n=1)
        if (length(ans) < 1) break
        logL = sum(dnorm(x, mean=ans$x, sd=ans$y, log=TRUE))
        print(c(Mean=ans$x, SD=ans$y, logLik=logL))
        flush.console()
      }
      invisible(Res)
    }
  }

  return(Res)
}

ORLI = function(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8) # Consider doing in log scale
{
  if (length(y1) > 1) stop("This does not support multiple strata!")
  if (any(c(y1, n1 - y1, y2, n2 - y2) < 0) | n1*n2 == 0) stop("Check the input!")
  p1 = y1/n1
  p2 = y2/n2
  o1 = y1/(n1 - y1)                 # odd of test (active) group
  o2 = y2/(n2 - y2)                 # odd of control (placebo) group
  OR0 = y1/y2*(n2 - y2)/(n1 - y1)   # point estimate of odds ratio (OR)

  if (y1 == 0 | y1 == n1 | y2 == 0 | y2 == n2) {
    maxLL = 0
  } else {
    maxLL = y1*log(p1) + (n1 - y1)*log(1 - p1) + y2*log(p2) + (n2 - y2)*log(1 - p2) # lchoose part removed
  }

  n = n1 + n2
  if (!missing(k)) {
    logk = log(k)
  } else if (n == 1) {
    logk = log(2/(1 - conf.level))
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 1)/(n - 1)) # - 1 regardless of number of parameters
    logk = min(logk, log(2/(1 - conf.level))) # Pawitan p240 k = 20 -> p < 0.05
  }

  Obj = function(or) {  # find or points of increased obj fx value (ofv) by v0
    A = n2*(or - 1)                         # eq 13
    B = n1*or + n2 - (y1 + y2)*(or - 1)
    C1 = -(y1 + y2)
    p2t = (-B + sqrt(B*B - 4*A*C1))/(2*A)
    p1t = p2t*or/(1 + p2t*(or - 1))

    if (p1t < eps | p1t > 1 - eps | p2t < eps | p2t > 1 - eps) {
      ll = 0
    } else {
      ll = y1*log(p1t) + (n1 - y1)*log(1 - p1t) + y2*log(p2t) + (n2 - y2)*log(1 - p2t) # lchoose part removed
    }
    return(maxLL - ll - logk)
  }

  if (y1 == 0 & y2 == 0) {           # Case 1; o1=0 & o2=0
    LL = 0
    UL = Inf
  } else if (y1 == 0 & y2 < n2) {    # Case 2: o1=0 & 0 < o2 < Inf
    LL = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 == 0 & y2 == n2) {   # Case 3: o1=0 & o2=Inf
    LL = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 < n1 & y2 == 0) {    # Case 4: 0 < o1 < Inf & o2=0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    UL = Inf
  } else if (y1 < n1 & y2 < n2) {    # Case 5: 0 < o1 < Inf & 0 < o2 < Inf
#    LE = 3*sqrt(1/y1 + 1/(n1 - y1) + 1/y2 + 1/(n2 - y2))
    rTemp = try(uniroot(Obj, c(1e-4, OR0)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    rTemp = try(uniroot(Obj, c(OR0, 1e4)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 < n1 & y2 == n2) {   # Case 6: 0 < o1 < 1 & o2=Inf
    LL = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 == n1 & y2 == 0) {   # Case 7: o1=Inf & o2=0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    UL = Inf
  } else if (y1 == n1 & y2 < n2) {   # Case 8: o1=Inf & 0 < o2 < Inf
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    UL = Inf
  } else if (y1 == n1 & y2 == n2) {  # Case 9: o1=Inf & o2=Inf
    LL = 0
    UL = Inf
  }

  return(c(odd1 = o1, odd2 = o2, OR = OR0, lower = LL, upper = UL, k = exp(logk)))
}

RDLI = function(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8)
{
  if (length(y1) != 1 | length(n1) != 1 | (y1 < 0) | (n1 < 0) | !is.finite(y1) | !is.finite(n1)) stop("Check the input!")
  if (length(y2) != 1 | length(n2) != 1 | (y2 < 0) | (n2 < 0) | !is.finite(y2) | !is.finite(n2)) stop("Check the input!")
  if (n1 > 1/eps | n2 > 1/eps) stop("Too large n1 or n2!")

  p1 = y1/n1
  p2 = y2/n2
  RD0 = p1 - p2
  if (p1 == 0) p1 = eps # to prevent likelihood = 0 (loglihood is -inf)
  if (p2 == 0) p2 = eps # to prevent likelihood = 0 (loglihood is -inf)
  if (p1 == 1) p1 = 1 - eps # to prevent likelihood = 0 (loglihood is -inf)
  if (p2 == 1) p2 = 1 - eps # to prevent likelihood = 0 (loglihood is -inf)

  maxLL = y1*log(p1) + (n1 - y1)*log(1 - p1) + y2*log(p2) + (n2 - y2)*log(1 - p2) # lchoose part removed
  maxLL = ifelse(is.finite(maxLL), maxLL, 0)

  n = n1 + n2
  if (!missing(k)) {
    logk = log(k)
  } else if (n == 1) {
    logk = log(2/(1 - conf.level))    
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 1)/(n - 1)) # - 1 regardless of number of parameters
    logk = min(logk, log(2/(1 - conf.level))) # Pawitan p240 k = 20 -> p < 0.05
  }

  Obj = function(rd) {
    L3 = n1 + n2                                   # eq 27, These could be float number!!!
    L2 = (n1 + 2*n2)*rd - L3 - y1 - y2
    L1 = (n2*rd - L3 - 2*y2)*rd + y1 + y2
    L0 = y2*rd*(1 - rd)
    q = L2^3/(3*L3)^3 - L1*L2/(6*L3^2) + L0/(2*L3) # eq 28
    if (!is.finite(q) | abs(q) < eps) q = 0
    p = sign(q)*sqrt(max(0, L2^2/(3*L3)^2 - L1/(3*L3)))
    a = (pi + ifelse(p == 0, acos(0), acos(min(max(q/p^3, -1), 1))))/3
    p2t = min(max(eps, 2*p*cos(a) - L2/(3*L3)), 1 - eps)
    p1t = min(max(eps, p2t + rd), 1 - eps)

    ll = y1*log(p1t) + (n1 - y1)*log(1 - p1t) + y2*log(p2t) + (n2 - y2)*log(1 - p2t) # lchoose part removed
    ll = ifelse(is.finite(ll), ll, 0)
    return(maxLL - ll - logk)
  }

  if (RD0 < -1 + eps) {
    LL = -1
  } else {
    rTemp = try(uniroot(Obj, c(-1 + eps, RD0 + eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = -1 }
  }
  if (RD0 > 1 - eps) {
    UL = 1
  } else {
    rTemp = try(uniroot(Obj, c(RD0 - eps, 1 - eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = 1 }
 }

  Res = c(p1 = y1/n1, p2 = y2/n2, RD = RD0, lower = LL, upper = UL, k = exp(logk))
  return(Res)
}

LIvRatio = function(x, y, k, conf.level=0.95)
{
  x = x[!is.na(x)] ; n1 = length(x) ; n1v1 = sum((x - mean(x))^2) ; v1 = n1v1/n1
  y = y[!is.na(y)] ; n2 = length(y) ; n2v2 = sum((y - mean(y))^2) ; v2 = n2v2/n2
  if (!is.numeric(x) | sum(is.infinite(x) > 0) | sum(is.nan(x)) > 0 | n1 < 3 | length(unique(x)) == 1) stop("Check the input!")
  if (!is.numeric(y) | sum(is.infinite(y) > 0) | sum(is.nan(y)) > 0 | n2 < 3 | length(unique(y)) == 1) stop("Check the input!")

  R0 = v1/v2
  n = n1 + n2
  df2 = n - max(2.4, 1.75*max(n1, n2)/min(n1, n2)) # df of denominator
  maxLL = -(n1*(log(2*pi*v1) + 1) + n2*(log(2*pi*v2) + 1))/2
  if (!missing(k)) {
    logk = log(k)
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, df2)/df2) # two parameters
    logk = min(logk, log(2/(1 - conf.level)))
  }

  Obj = function(r) {
    mLL = function(v2t) (n1*log(2*pi*r*v2t) + n1v1/(r*v2t) + n2*log(2*pi*v2t) + n2v2/v2t)/2
    v2t = nlminb(v2, mLL, lower=1e-8, upper=1e6*v2)
    maxLL + v2t$objective - logk
  }

  options(warn=-1)
  LL = uniroot(Obj, c(0, R0))$root
  UL = uniroot(Obj, c(R0, 1e4))$root
  options(warn=0)

  Res = c(group1=v1, group2=v2, PE=R0, LL=LL, UL=UL)
  Res = rbind(Res, sqrt(Res))
  rownames(Res) = c("var", "sd")
  attr(Res, "logk") = logk
  attr(Res, "maxLL") = maxLL
  attr(Res, "conf.level") = conf.level
  return(Res)
}

LRT = function(n, pFull, pReduced, logLikFull, logLikReduced, alpha=0.05, Wilks=FALSE)
{
  if (n - pFull < 1 | pFull < pReduced | alpha <= 0 | alpha >= 0.5) stop("Check the input!")

  dP = pFull - pReduced
  dLL = max(logLikFull - logLikReduced, 0)

  if (Wilks) {
    cut0 = qchisq(1 - alpha, dP)/2
    Chisq = 2*dLL
    pval = 1 - pchisq(Chisq, dP)
  } else {
    cut0 = n/2*log(1 + dP*qf(1 - alpha, dP, n - pFull)/(n - pFull))
    Fval = (exp(dLL*2/n) - 1)*(n - pFull)/dP
    pval = 1 - pf(Fval, dP, n - pFull)
  }

  if (dLL > cut0) { Verdict = "Full model is better."
  } else if (dLL < cut0) { Verdict = "Reduced model is better."
  } else { Verdict = "Both models are equivalent." }

  if (Wilks) {
    Res = c(n = n, paraFull = pFull, paraReduced = pReduced, deltaPara = dP,
               cutoff = cut0, deltaLogLik = dLL, Chisq=Chisq, pval=pval)
    if (n < 100) attr(Res, "Warning") = "Sample size (n) is too small to use Wilks' theorem!"
  } else {
    Res = c(n = n, paraFull = pFull, paraReduced = pReduced, deltaPara = dP,
               cutoff = cut0, deltaLogLik = dLL, Fval=Fval, pval=pval)
  }
  attr(Res, "Verdict") = Verdict
  return(Res)
}

RRLI = function(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8)
{
  if (length(y1) > 1) stop("This does not support multiple strata!")
  if (any(c(y1, n1 - y1, y2, n2 - y2) < 0) | n1*n2 == 0) stop("Check the input!")
  p1 = y1/n1                 # p of test (active) group
  p2 = y2/n2                 # p of control (placebo) group
  RR0 = p1/p2                # point estimate of relative risk (RR)

  n = n1 + n2
  if (!missing(k)) {
    logk = log(k)
  } else if (n == 1) {
    logk = log(2/(1 - conf.level))
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 1)/(n - 1)) # - 1 regardless of number of parameters
    logk = min(logk, log(2/(1 - conf.level))) # Pawitan p240 k = 20 -> p < 0.05
  }

  LE = 1e4*(exp(logk)/(n1 + n2))
#  logk = min(log(maxk), logk)
  p1 = min(1 - eps, max(eps, p1))
  p2 = min(1 - eps, max(eps, p2))
  if (y1 == 0 | y1 == n1 | y2 == 0 | y2 == n2) {
    maxLL = 0
  } else {
    maxLL = y1*log(p1) + (n1 - y1)*log(1 - p1) + y2*log(p2) + (n2 - y2)*log(1 - p2) # lchoose part removed
  }

  Obj = function(rr) {
    A = (n1 + n2)*rr
    B = n1*rr + y1 + n2 + y2*rr
    C1 = y1 + y2
    p2t = min(1 - eps, max(eps, (B - sqrt(B*B - 4*A*C1))/(2*A)))
    p1t = min(1 - eps, max(eps, p2t*rr))

    ll = y1*log(p1t) + (n1 - y1)*log(1 - p1t) + y2*log(p2t) + (n2 - y2)*log(1 - p2t) # lchoose part removed
    return(maxLL - ll - logk)
  }

  if (y1 == 0 & y2 == 0) {                         # Case 1: p1 = 0 & p2 = 0
    LL = 0
    UL = Inf
  } else if (y1 == 0 & y2 > 0 & y2 < n2) {         # Case 2: p1 = 0 & 0 < p2 < 1
    LL = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = 1e9 }
  } else if (y1 == 0 & y2 == n2) {                 # Case 3: p1 = 0 & p2 = 1
    LL = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 > 0 & y1 < n1 & y2 == 0) {         # Case 4: 0 < p1 < 1 & p2 = 0
    rTemp = try(uniroot(Obj, c(eps, 1e2)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    UL = Inf
  } else if (y1 > 0 & y1 < n1 & y2 > 0 & y2 < n2) {# Case 5: 0 < p1 < 1 & 0 < p2 < 1
    rTemp = try(uniroot(Obj, c(eps, RR0 + eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    rTemp = try(uniroot(Obj, c(RR0 - eps, RR0 + LE)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 > 0 & y1 < n1 & y2 == n2) {        # Case 6: 0 < p1 < 1 & p2 = 1
    rTemp = try(uniroot(Obj, c(eps, RR0 + eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    rTemp = try(uniroot(Obj, c(RR0 - eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 == n1 & y2 == 0) {                 # Case 7: p1 = 1 &  p2 = 0
    rTemp = try(uniroot(Obj, c(eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = 1/rTemp$root
    } else { LL = 0 }
    UL = Inf
  } else if (y1 == n1 & y2 > 0 & y2 < n2) {        # Case 8: p1 = 1 & 0 < p2 < 1
    rTemp = try(uniroot(Obj, c(eps, RR0 + eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    rTemp = try(uniroot(Obj, c(RR0 - eps, 1e9)), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  } else if (y1 == n1 & y2 == n2) {                # Case 9: p1 = 1 &  p2 = 1
    rTemp = try(uniroot(Obj, c(eps, RR0 + eps)), silent=T)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = 0 }
    rTemp = try(uniroot(Obj, c(RR0 - eps, min(1 + 1/LL, 1e9))), silent=T)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = Inf }
  }
  return(c(p1 = y1/n1, p2 = y2/n2, RR = RR0, lower = LL, upper = UL, k = exp(logk)))
}

LIvar = function(s1, n1, k, conf.level=0.95)
{
  n1v1 = (n1 - 1)*s1^2
  v1 = n1v1/n1
  maxLL = -n1*(log(2*pi*v1) + 1)/2

  if (!missing(k)) {
    logk = log(k)
  } else {
    logk = n1/2*log(1 + qf(conf.level, 1, n1 - 1.2)/(n1 - 1.2)) # 1.2 is empirical
    logk = min(logk, log(2/(1 - conf.level)))
  }

  O2 = function(th) maxLL + (n1*log(2*pi*th) + n1v1/th)/2 - logk

  options(warn=-1)
  varLL = uniroot(O2, c(1e-8, v1))$root
  varUL = uniroot(O2, c(v1, 1e6*v1))$root
  options(warn=0)

  Res = c(PE=v1, LL=varLL, UL=varUL)
  Res = rbind(Res, sqrt(Res))
  rownames(Res) = c("var", "sd")
  attr(Res, "n") = n1
  attr(Res, "k") = exp(logk)
  attr(Res, "log(k)") = logk
  attr(Res, "maxLogLik") = maxLL
  return(Res)
}

OneTwo = function(x, alpha=0.05)
{
  x = x[!is.na(x)] ; n0 = length(x) ; sxx = sum(x^2) ; sx = sum(x)
  if (!is.numeric(x) | sum(is.infinite(x) > 0) | sum(is.nan(x)) > 0 | n0 < 3 | length(unique(x)) == 1) stop("Check the input!")
  m0 = sx/n0
  v0 = sxx/n0 - m0^2
  s0 = sqrt(v0)
  logL0 = -n0*(log(2*pi*v0) + 1)/2
  r1 = list(n=n0, mean=m0, var=v0, sd=s0, logLik=logL0)
  p1 = 1
  mLL = function(TH, d0) {
    el1 = dnorm(d0, mean=TH[1], sd=TH[2])
    el2 = dnorm(d0, mean=TH[3], sd=TH[4])

    O2 = function(p0) -sum(log(p0*el1 + (1 - p0)*el2))
    rt = optimize(O2, c(0, 1))
    p1 <<- rt$minimum
    return(rt$objective)
  }

  m0LL = min(x, na.rm=T)
  m0UL = max(x, na.rm=T)
  r2 = nlminb(c(0.8*m0, s0, 1.2*m0, s0), mLL, lower=c(m0LL, 1e-4, m0, 1e-4),
              upper=c(m0, s0, m0UL, s0), d0=x)

  el1 = p1*dnorm(x, mean=r2$par[1], sd=r2$par[2])
  el2 = (1 - p1)*dnorm(x, mean=r2$par[3], sd=r2$par[4])
  n1 = sum(el1 > el2)
  n2 = n0 - n1

  r3 = LRT(n0, pFull=4, pReduced=2, -r2$objective, logL0, alpha=alpha)
  r4 = LRT(n0, pFull=4, pReduced=2, -r2$objective, logL0, alpha=alpha, Wilks=T)

  r0 = NULL
  r0$Estimate = data.frame(Model=c("One group", "Two group", ""),
                           GroupNo = c(1, 1, 2),
                           n = c(n0, n1, n2),
                           Mean = c(m0, r2$par[1], r2$par[3]),
                           SD = c(s0, r2$par[2], r2$par[4]),
                           Prior = c(1, p1, 1 - p1))
  r0$Delta = data.frame(Model = c("One group", "Two group", "Difference"),
                        nPara = c(2, 4, 2),
                        logLik = c(logL0, -r2$objective, max(-r2$objective - logL0, 0)))
  r0$Statistic = data.frame(Distribution = c("F", "Chisq"),
                            CutoffLogLik = c(r3["cutoff"], r4["cutoff"]), # cut-off value in log-likelihood
                            StatCrit = c(qf(1 - alpha, 2, n0 - 2), qchisq(1 - alpha, 2)), # statistics critical value
                            Statistic = c(r3["Fval"], r4["Chisq"]),
                            pval = c(r3["pval"], r4["pval"]),
                            Favor = c(ifelse(r3["pval"] < alpha, "Two group", "One group"), ifelse(r4["pval"] < alpha, "Two group", "One group")))
  attr(r0$Statistic, "alpha") = alpha
  return(r0)
}

LIpois = function(x, k, n=1, conf.level=0.95, eps=1e-8)
{
  if (!is.finite(x)) stop("Check the input!")
  n0 = length(x)
  if (n0 == 1) { # x is mean x
    sx = x*n
  } else {       # x is raw data vector
    sx = sum(x)
    n  = n0
  }

  Lam0 = sx/n    # PE for mean
  maxLL = sx*log(Lam0) - n*Lam0 # excluding factorial part

  if (!missing(k)) {
    logk = log(k)
  } else if (n == 1) {
    logk = log(2/(1 - conf.level))
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 1)/(n - 1))
    logk = min(logk, log(2/(1 - conf.level))) # Pawitan p240 k = 20 -> p < 0.05
  }

  Obj = function(lam, ylevel) {
    ll = ifelse(lam > 0, sx*log(lam) - n*lam, 0)
    maxLL - ll - ylevel
  }
  if (Lam0 > 0) {
    LL = uniroot(Obj, c(eps, Lam0), ylevel=logk)$root
  } else {
    LL = 0
  }
  if (!is.finite(maxLL)) {
    UL = Inf
  } else {
    UL = uniroot(Obj, c(Lam0, 1e9), ylevel=logk)$root
  }
  Res = c(PE=Lam0, LL=LL, UL=UL)
  attr(Res, "n") = n
  attr(Res, "k") = exp(logk)
  attr(Res, "logk") = logk
  attr(Res, "maxLL without factorial") = maxLL
  return(Res)
}

LInormVar = function(x, k, conf.level=0.95)
{
  x = x[!is.na(x)]
  n0 = length(x)
  if (!is.numeric(x) | sum(is.infinite(x) > 0) | sum(is.nan(x)) > 0 | n0 < 3 | length(unique(x)) == 1) stop("Check the input!")
  n0v0 = sum((x - mean(x))^2)
  v0 = n0v0/n0
  maxLL = -n0*(log(2*pi*v0) + 1)/2

  if (!missing(k)) {
    logk = log(k)
  } else {
    logk = n0/2*log(1 + qf(conf.level, 1, n0 - 1.2)/(n0 - 1.2)) # 1.2 is empirical
    logk = min(logk, log(2/(1 - conf.level)))
  }

  O2 = function(th) maxLL + (n0*log(2*pi*th) + n0v0/th)/2 - logk

  options(warn=-1)
  varLL = uniroot(O2, c(1e-8, v0))$root
  varUL = uniroot(O2, c(v0, 1e6*v0))$root
  options(warn=0)

  Res = c(PE=v0, LL=varLL, UL=varUL)
  Res = rbind(Res, sqrt(Res))
  rownames(Res) = c("var", "sd")
  attr(Res, "n") = n0
  attr(Res, "k") = exp(logk)
  attr(Res, "log(k)") = logk
  attr(Res, "maxLogLik") = maxLL
  return(Res)
}

LIbin = function(y, n, k, conf.level=0.95, eps=1e-8)
{
  if (length(y) != 1 | length(n) != 1) stop("Current version supports only length 1 data")
  if (any(y < 0) | any(n < 0) | any(!is.finite(y)) | any(!is.finite(n))) stop("Check the input!")

  if (!missing(k)) {
    logk = log(k)
  } else if (n == 1) {
    logk = log(2/(1 - conf.level))
  } else {
    logk = n/2*log(1 + qf(conf.level, 1, n - 1)/(n - 1))
    logk = min(logk, log(2/(1 - conf.level)))
  }

  p0 = y/n
  if (y == 0 | y == n) {
    LE = logk/sqrt(n)                         # initial guess of the limit of error
    maxLogL = 0                               # lchoose removed
  } else {
    LE = logk*sqrt(p0*(1 - p0))               # initial guess of the limit of error
    maxLogL = y*log(p0) + (n - y)*log(1 - p0) # lchoose removed
  }

  Obj = function(p)  {
    logL = ifelse(p < 1e-300 | p > 1 - 1e-300, 0, y*log(p) + (n - y)*log(1 - p))
    return(maxLogL - logL - logk)
  }

  if (p0 < eps) {
    LL = 0
  } else {
    rTemp = try(uniroot(Obj, c(max(eps, p0 - LE), p0 + eps)), silent=TRUE)
    if (!inherits(rTemp, "try-error")) { LL = rTemp$root
    } else { LL = max(p0 - LE, 0) }
  }

  if (p0 > 1 - eps) {
    UL = 1
  } else {
    rTemp = try(uniroot(Obj, c(p0 - eps, min(p0 + LE, 1 - eps))), silent=TRUE)
    if (!inherits(rTemp, "try-error")) { UL = rTemp$root
    } else { UL = min(p0 + LE, 1) }
  }

  Res = c(y=y, n=n, PE=p0, LL=LL, UL=UL, k=exp(logk))
  return(Res)
}

LBCIvar = function(x, conf.level=0.95)
{
  x = x[!is.na(x)] ; n0 = length(x)
  if (!is.numeric(x) | sum(is.infinite(x) > 0) | sum(is.nan(x)) > 0 | n0 < 3 | length(unique(x)) == 1) stop("Check the input!")
  n0v0 = sum(x^2) - sum(x)^2/n0
  v0   = n0v0/n0
  maxLL = -n0*(log(2*pi*v0) + 1)/2

  logk0 = n0/2*log(1 + qf(conf.level, 1, n0 - 2)/(n0 - 2)) # initial guess for logk
  logk0 = min(logk0, log(2/(1 - conf.level)))

  O1 = function(th, logk) maxLL + (n0*log(2*pi*th) + n0v0/th)/2 - logk
  O2 = function(logk) {
    varLL = uniroot(O1, interval=c(1e-8, v0), logk=logk)$root
    varUL = uniroot(O1, interval=c(v0, 1e6*v0), logk=logk)$root
    pchisq(n0v0/varLL, n0 - 1) - pchisq(n0v0/varUL, n0 - 1) - conf.level
  }

  options(warn=-1)
  logk = uniroot(O2, interval=c(0.5*logk0, 2*logk0))$root
  varLL = uniroot(O1, interval=c(1e-8, v0), logk=logk)$root   # One more after fixing logk
  varUL = uniroot(O1, interval=c(v0, 1e6*v0), logk=logk)$root # One more after fixing logk
  options(warn=0)

  Res = cbind(PE=v0, LL=varLL, UL=varUL)
  Res = rbind(Res, sqrt(Res))
  rownames(Res) = c("var", "sd")
  attr(Res, "n") = n0
  attr(Res, "k") = exp(logk)
  attr(Res, "log(k)") = logk
  attr(Res, "maxLogLik") = maxLL
  return(Res)
}

\name{LInormVar}
\alias{LInormVar}
\title{Likelihood Interval of sd and variance assuming Normal Distribution}
\description{
  Likelihood interval of sd and variance assuming normal distribution. This is estimated likelihood interval, not profile likelihood interval.
}
\usage{
  LInormVar(x, k, conf.level=0.95)
}
\arguments{
  \item{x}{a vector of observation}
  \item{k}{1/k likelihood interval will be calculated}
  \item{conf.level}{approximately corresponding confidence level. If k is specified, this is ignored.}
}
\details{
  It calculates likelihood interval of sd and variance assuming normal distribution in one group. The likelihood interval is asymmetric and there is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
}
\examples{
  x = c(-5.3, -4.5, -1.0, -0.7, 3.7, 3.9, 4.2, 5.5, 6.8, 7.4, 9.3)
  LInormVar(x, k=1/0.15) # Pawitan Ex10-9 p289
  LInormVar(x)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LIvar}
\alias{LIvar}
\title{Likelihood Interval of variance and sd assuming Normal Distribution with sample mean and sample size}
\description{
  Likelihood interval of sd and variance assuming normal distribution. This is estimated likelihood interval, not profile likelihood interval.
}
\usage{
  LIvar(s1, n1, k, conf.level=0.95)
}
\arguments{
  \item{s1}{standard deviation of the sample}
  \item{n1}{sample size}
  \item{k}{1/k likelihood interval will be calculated}
  \item{conf.level}{approximately corresponding confidence level. If k is specified, this is ignored.}
}
\details{
  It calculates likelihood interval of sd and variance assuming normal distribution in one group. The likelihood interval is asymmetric and there is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate on the population variance}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
}
\examples{
  x = c(-5.3, -4.5, -1.0, -0.7, 3.7, 3.9, 4.2, 5.5, 6.8, 7.4, 9.3)
  LInormVar(x)
  LIvar(sd(x), length(x))
}
\author{Kyun-Seop Bae k@acr.kr}

\name{ORLI}
\alias{ORLI}
\title{Odds Ratio and its Likelihood Interval between two groups without strata}
\description{
  Odds ratio and its likelihood interval between two groups without stratification
}
\usage{
  ORLI(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8)
}
\arguments{
  \item{y1}{positive event count of test (the first) group}
  \item{n1}{total count of the test (the first) group. Maximum allowable value is 1e8.}
  \item{y2}{positive event count of control (the second) group}
  \item{n2}{total count of control (the second) group. Maximum allowable value is 1e8.}
  \item{conf.level}{approximate confidence level to calculate k when k is missing.}
  \item{k}{1/k likelihood interval will be provided}
  \item{eps}{absolute value less than eps is regarded as negligible}
}
\details{
  It calculates risk (proportion) difference and its likelihood interval between the two groups. The likelihood interval is asymmetric, and there is no standard error in the output. This does not support stratification.
}
\value{
  There is no standard error.
  \item{odd1}{odd from the first group, y1/(n1 - y1)}
  \item{odd2}{odd from the second group, y2/(n2 - y2)}
  \item{OR}{odds ratio, odd1/odd2}
  \item{lower}{lower likelihood limit of OR}
  \item{upper}{upper likelihood limit of OR}
}
\examples{
  ORLI(7, 10, 3, 10)
  ORLI(3, 10, 7, 10)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LRT}
\alias{LRT}
\title{Likelihood Ratio Test}
\description{
  Likelihood ratio test with given fitting results, sample size, number of parameters, log-likelihoods, and alpha
}
\usage{
  LRT(n, pFull, pReduced, logLikFull, logLikReduced, alpha=0.05, Wilks=FALSE)
}
\arguments{
  \item{n}{number of observations}
  \item{pFull}{number of parameters of full model}
  \item{pReduced}{number of parameters of reduced model}
  \item{logLikFull}{log likelihood of full model}
  \item{logLikReduced}{log likelihood of reduced model}
  \item{alpha}{alpha value for type I error, significance level}
  \item{Wilks}{if TRUE, Wilks theorem (chi-square distribution) will be used, otherwise F distribution will be used.}
}
\details{
  It performs likelihood ratio test with given fitting results. The default test is using F distribution. For small n (i.e. less than 100), you need to use F distribution. 
  If the residuals are normally distributed, the delta -2 log likelihood (the difference between -2LL, the objective function value of each model) follows exactly an F-distribution, independent of sample size.
  When the distribution of the residuals is not normal (no matter what the distribution of the residuals is), it approaches a chi-square distribution as sample size increases (Wilks' theorem).
  The extreme distribution of the F-distribution (when the degrees of freedom in the denominator go to infinity) is chi-square distribution.
  The p-value from the F-distribution is slightly larger than the p-value from the chi-square distribution, meaning the F-distribution is more conservative. 
  The difference decreases as sample size increases.
}
\value{
  \item{n}{number of observations}
  \item{paraFull}{number of parameters of full model}
  \item{paraReduced}{number of parameters of reduced model}
  \item{deltaPara}{difference of parameter counts}
  \item{cutoff}{cutoff, threshold, critical value of log-likelihood for the test}
  \item{deltaLogLik}{difference of log likelihood, if negative 0 is used.}
  \item{Chisq or Fval}{statistics according to the used distribution Chi-square of F}
  \item{pval}{p-value of null hypothesis. i.e. the reduced model is better.}
  \item{Verdict}{the model preferred.}
}
\examples{
  LRT(20, 4, 2, -58.085, -60.087)
  LRT(20, 4, 2, -58.085, -60.087, Wilks=TRUE)
  LRT(20, 4, 2, -57.315, -66.159)
  LRT(20, 4, 2, -57.315, -66.159, Wilks=TRUE)

  r1 = lm(mpg ~ disp + drat + wt, mtcars)
  r2 = lm(mpg ~ disp + drat, mtcars)
  anova(r2, r1)
  LRT(nrow(mtcars), r1$rank, r2$rank, logLik(r1), logLik(r2))  
}
\references{
  \enumerate{
    \item Ruppert D, Cressie N, Carroll RJ. A Transformation/Weighting Model For Estimating Michaelis-Menten Parameters. School of Operations Research and Industrial Engineering, College of Engineering, Cornell University. Technical Report No. 796. May 1988.
    \item Scheff\eacute{} H. The Analysis of Variance. Wiley. 1959.
    \item Wilks SS. The Large-Sample Distribution of the Likelihood Ratio for Testing Composite Hypotheses. \emph{Annals Math. Statist.} 1938;9:60-62
  }
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LIbin}
\alias{LIbin}
\title{Likelihood Interval for a Proportion or a Binomial Distribution}
\description{
  Likelihood interval of a proportion in one group
}
\usage{
  LIbin(y, n, k, conf.level=0.95, eps=1e-8)
}
\arguments{
  \item{y}{positive event count of a group}
  \item{n}{total count of a group}
  \item{k}{1/k likelihood interval will be calculated}
  \item{conf.level}{approximately corresponding confidence level. If k is specified, this is ignored.}
  \item{eps}{Values less than eps are considered as 0.}
}
\details{
  It calculates likelihood interval of a proportion in one group. The likelihood interval is asymmetric and there is no standard error in the output. If you need percent scale, multiply the output by 100.
}
\value{
  \item{y}{positive (concerning) event count}
  \item{n}{total trial count}
  \item{PE}{maximum likelihood estimate on the proportion}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
}
\examples{
  LIbin(3, 14, k=2)
  LIbin(3, 14, k=5)
  LIbin(3, 14, k=15)
  LIbin(3, 14)
# binom.test(3, 14)
# prop.test(3, 14) 
}
\seealso{
  \code{binom.test}, \code{prop.test}
}
\references{
  Fisher RA. Statistical methods and scientific inference. 3e. 1973. pp68-76.  
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LIvRatio}
\alias{LIvRatio}
\title{Likelihood Interval of the ratio of two variances from two groups}
\description{
  Likelihood interval of  the ratio of two variances from two groups assuming normal distribution. Likelihood interval usually gives a narrower interval when the likelihood function is asymmetric.
}
\usage{
  LIvRatio(x, y, k, conf.level=0.95)
}
\arguments{
  \item{x}{observations from the first group, the test group, used for the numerator}
  \item{y}{observations from the second group, the control group, used for the denominator}
  \item{k}{1/k likelihood interval will be provided}  
  \item{conf.level}{approximate confidence level}
}
\details{
  It calculates likelihood interval of the ratio of two variances from two groups. Likelihood interval usually gives a narrower interval when the likelihood function is asymmetric.
}
\value{
  \item{PE}{maximum likelihood estimate on the ratio}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
  \item{logk}{log(k) value used for LI}
  \item{maxLL}{maximum log likelihood}
  \item{conf.level}{approximate confidence level}  
}
\examples{
  LIvRatio(mtcars$drat, mtcars$wt)
  var.test(mtcars$drat, mtcars$wt)
  LIvRatio(mtcars$qsec, mtcars$wt)
  var.test(mtcars$qsec, mtcars$wt)
  LIvtest(sd(mtcars$qsec), nrow(mtcars), sd(mtcars$wt), nrow(mtcars))
}
\author{Kyun-Seop Bae k@acr.kr}

\name{RRLI}
\alias{RRLI}
\title{Relative Risk and its Likelihood Interval between two groups without strata}
\description{
  Relative risk and its likelihood interval between two groups without stratification
}
\usage{
  RRLI(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8)
}
\arguments{
  \item{y1}{positive event count of test (the first) group}
  \item{n1}{total count of the test (the first) group. Maximum allowable value is 1e8.}
  \item{y2}{positive event count of control (the second) group}
  \item{n2}{total count of control (the second) group. Maximum allowable value is 1e8.}
  \item{conf.level}{approximate confidence level to calculate k when k is missing.}
  \item{k}{1/k likelihood interval will be provided}
  \item{eps}{absolute value less than eps is regarded as negligible}
}
\details{
  It calculates relative risk and its likelihood interval between the two groups. The likelihood interval is asymmetric, and there is no standard error in the output. This does not support stratification.
}
\value{
  There is no standard error.
  \item{p1}{proportion from the first group, y1/n1}
  \item{p2}{proportion from the second group, y2/n2}
  \item{RR}{relative risk, p1/p2}
  \item{lower}{lower likelihood limit of RR}
  \item{upper}{upper likelihood limit of RR}
}
\examples{
  RRLI(7, 10, 3, 10)
  RRLI(3, 10, 7, 10)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LIpois}
\alias{LIpois}
\title{Likelihood Interval of the Mean assuming Poisson Distribution}
\description{
  Likelihood interval of lambda assuming Poisson distribution.
}
\usage{
  LIpois(x, k, n = 1, conf.level = 0.95, eps = 1e-8)
}
\arguments{
  \item{x}{raw data vector or a mean value.  If the length of x is 1, x is considered as a mean.}
  \item{k}{1/k likelihood interval will be calculated.}
  \item{n}{number of observations. If the length of x is 1, x is considered as the mean.}
  \item{conf.level}{approximately corresponding confidence level. If k is specified, this is ignored.}
  \item{eps}{estimated values less than this eps are considered as 0.}
}
\details{
  It calculates likelihood interval of mean(lambda) assuming Poisson distribution. The likelihood interval is asymmetric and there is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate on the lambda}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
  \item{n}{number of observations}
  \item{k}{1/k likelihood interval provided}
  \item{logk}{log(k) of k value}
  \item{maxLL without factorial}{maximum log likelihood without factorial part}
}
\examples{
  LIpois(4, k=15)     # Fisher
  LIpois(4, k=exp(2)) # Edwards
  LIpois(4, k=1/0.15) # Pawitan
  LIpois(4, k=8)      # Rhode
  LIpois(4, n=4)      # Bae
  LIpois(4)           # Bae
#  poisson.test(4)
  LIpois(4, k=32)     # 0.7454614 11.7893612
  LIpois(2.1, n=60)   # 1.750222   2.493533
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LInorm}
\alias{LInorm}
\title{Likelihood Interval of mean, sd and variance assuming Normal Distribution}
\description{
  Likelihood interval of mean and sd assuming normal distribution. This is estimated likelihood interval, not profile likelihood interval.
}
\usage{
  LInorm(x, k, conf.level=0.95, PLOT="", LOCATE=FALSE, Resol=201)
}
\arguments{
  \item{x}{a vector of observation}
  \item{k}{1/k likelihood interval will be calculated}
  \item{conf.level}{approximately corresponding confidence level. If k is specified, this is ignored.}
  \item{PLOT}{"1d" for profile plot or "2d" for contour plot.}
  \item{LOCATE}{use locater. This works only with PLOT="2D" option.}
  \item{Resol}{resolution for plot. This works only with PLOT=TRUE option.}
}
\details{
  It calculates likelihood interval of mean and sd assuming normal distribution in one group. There is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
}
\examples{
  x = c(-5.3, -4.5, -1.0, -0.7, 3.7, 3.9, 4.2, 5.5, 6.8, 7.4, 9.3)
  LInorm(x, k=1/0.15) # Pawitan Ex10-9 p289
  LInorm(x)
  LInorm(x, PLOT="1d")
  LInorm(x, PLOT="2d", LOCATE=TRUE)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LBCIvar}
\alias{LBCIvar}
\title{Likelihood Based Confidence Interval of sd and variance assuming Normal Distribution}
\description{
  Likelihood based confidence interval of sd and variance assuming normal distribution. It usually shows narrower interval than convenrtional chi-square interval. This uses estimated likelihood, not profile likelihood. 
}
\usage{
  LBCIvar(x, conf.level=0.95)
}
\arguments{
  \item{x}{a vector of observation}
  \item{conf.level}{confidence level}
}
\details{
  It calculates (same height) likelihood based confidence interval of sd and variance assuming normal distribution in one group. The likelihood interval is asymmetric and there is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
}
\examples{
  LBCIvar(lh)
  (length(lh) - 1)*var(lh)/qchisq(c(0.975, 0.025), length(lh) - 1)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LIvtest}
\alias{LIvtest}
\title{Likelihood Interval of variance and sd assuming Normal Distribution using means and SDs}
\description{
  Likelihood interval of variance and sd assuming normal distribution. This is estimated likelihood interval, not profile likelihood interval.
}
\usage{
  LIvtest(s1, n1, s2, n2, k, conf.level=0.95)
}
\arguments{
  \item{s1}{sample standard deviation of the first group}
  \item{n1}{sample size of the first group}
  \item{s2}{sample standard deviation of the second group}
  \item{n2}{sample size of the second group}
  \item{k}{1/k likelihood interval will be calculated}
  \item{conf.level}{approximate confidence level. If k is specified, this is ignored.}
}
\details{
  It calculates likelihood interval of variance and sd using sufficient statistics. There is no standard error in the output.
}
\value{
  \item{PE}{maximum likelihood estimate on the ratio}
  \item{LL}{lower limit of likelihood interval}
  \item{UL}{upper limit of likelihood interval}
  \item{logk}{log(k) value used for LI}
  \item{maxLL}{maximum log likelihood}
  \item{conf.level}{approximate confidence level}  
}
\examples{
  LIvtest(10.5, 3529, 8.9, 5190)
  LIvtest(3, 10, 2, 10)
  LIvtest(3, 10, 2, 10, k=15)
}
\author{Kyun-Seop Bae k@acr.kr}

\name{LBI-package}
\alias{LBI-package}
\alias{LBI}
\docType{package}
\title{Likelihood Based Inference}
\description{
It conducts likelihood based inference.
}
\details{
  Modern likelihood concept and maximum likelihood estimation are established by Fisher RA, while Likelihood Ratio Test (LRT) is established by Neyman J. Post-Fisher methods - generalized linear model, survival analysis, and mixed effects model - are all likelihood based. Inferences from the perspective of Fisherian and pure likelihoodist are suggested here.
}
\author{Kyun-Seop Bae <k@acr.kr>}

\references{
\enumerate{
\item Wilks SS. The Large-sample Distribution of the Likelihood Ratio for Testing Composite Hypotheses. Ann Math Stat. 1938;9(1):60-62.
\item Edwards AWF. Likelihood. 1972.
\item Fisher RA. Statistical Methods and Scientific Inference. 3e. 1973.
\item Bates DM, Watts DG. Nonlinear Regression Analysis and its Application. 1988.
\item Ruppert D, Cressie N, Carroll RJ. A Transformation/Weighting Model for Estimating Michaelis-Menten Parameters. Cornell University Technical Report 796. 1988.
\item Royall R. Statistical Evidence. 1997.
\item Pinheiro JC, Bates DM. Mixed Effects Models in S and S-PLUS. 2000.
\item Pawitan Y. In All Likelihood: Statistical Modelling and Inference Using Likelihood. 2001.
\item Lehmann EL. Fisher, Nayman, and the Creation of Classical Statistics. 2011.
\item Rohde CA. Introductory Statistical Inference with the Likelihood Function. 2014.
\item Held L, Bov\eacute{} DS. Likelihood and Bayesian Inference. 2020.
}
}

\name{OneTwo}
\alias{OneTwo}
\title{Likelihood Ratio Test for One group vs Two group gaussian mixture model}
\description{
 With a given vector, it performs likelihood ratio test which model - one or two group - is better.
}
\usage{
  OneTwo(x, alpha=0.05)
}
\arguments{
  \item{x}{a vector of numbers}
  \item{alpha}{alpha value for type I error, significance level}
}
\details{
  It performs likelihood ratio test using both F distribution and Chi-square distribution (by Wilks' theorem).
}
\value{
  \item{Estimate}{n, Mean, SD for each group assumption and prior probability of each group in two group model}
  \item{Delta}{delta number of parameters and log-likelihoods}
  \item{Statistic}{Statistics from both the F distribution and Chi-square distribtuion. Cutoff is in terms of log-likelihood not the statistic.}
}
\examples{
  OneTwo(c(7, 5, 17, 13, 16, 5, 7, 3, 8, 10, 8, 14, 14, 11, 14, 17, 2, 12, 15, 19))
  OneTwo(c(5, 3, 0, 6, 5, 2, 6, 6, 4, 4, 15, 13, 18, 18, 19, 14, 19, 13, 19, 18))
}
\author{Kyun-Seop Bae k@acr.kr}

\name{RDLI}
\alias{RDLI}
\title{Risk (Proportion) Difference and its Likelihood Interval between two groups without strata}
\description{
  Risk difference and its likelihood interval between two groups without stratification
}
\usage{
  RDLI(y1, n1, y2, n2, conf.level=0.95, k, eps=1e-8)
}
\arguments{
  \item{y1}{positive event count of test (the first) group}
  \item{n1}{total count of the test (the first) group. Maximum allowable value is 1e8.}
  \item{y2}{positive event count of control (the second) group}
  \item{n2}{total count of control (the second) group. Maximum allowable value is 1e8.}
  \item{conf.level}{approximate confidence level to calculate k when k is missing.}
  \item{k}{1/k likelihood interval will be provided}
  \item{eps}{absolute value less than eps is regarded as negligible}
}
\details{
  It calculates risk (proportion) difference and its likelihood interval between the two groups. The likelihood interval is asymmetric, and there is no standard error in the output. This does not support stratification.
}
\value{
  There is no standard error.
  \item{p1}{proportion from the first group, y1/n1}
  \item{p2}{proportion from the second group, y2/n2}
  \item{RD}{risk difference, p1 - p2}
  \item{lower}{lower likelihood limit of RD}
  \item{upper}{upper likelihood limit of RD}
}
\examples{
  RDLI(7, 10, 3, 10)
  RDLI(3, 10, 7, 10)
}
\author{Kyun-Seop Bae k@acr.kr}
